"""
Speed of mobile to represent the ratio of waiting time.
Data is retrieved from http://ai-benchmark.com/ranking_detailed.html, using values from MobileNet-V2, NN-FP16.
"""

MOBILE_RATIO = {"vivo iQOO Z1": "4.2", "Xiaomi Redmi Note 10": "8.1", "Huawei P40 Pro+": "4.4", "Honor 30 Pro+": "4.3", "Huawei P40": "4.3", "Huawei Mate 30 5G": "4.4", "Honor V30 Pro 5G": "4.3", "Realme X50 Pro 5G": "9.8", "Realme X2 Pro": "8.6", "Xiaomi Mi 10 Pro 5G": "8.1", "Oppo Find X2 Pro": "11", "Samsung Galaxy S20+ 5G": "9.7", "Samsung Galaxy S20": "12", "Samsung Galaxy S20 Ultra 5G": "9.9", "Samsung Galaxy S20+": "12", "Samsung Galaxy S20 5G": "9.9", "LG V60 ThinQ 5G": "8.1", "Motorola Edge+": "9.1", "Xiaomi Poco F2 Pro": "9.3", "OnePlus 8": "9", "Oppo Find X2": "9.6", "Xiaomi Redmi K30 Pro Zoom": "9.9", "vivo X50 Pro+": "9.9", "vivo iQOO 3 5G": "9.9", "Xiaomi Mi 10 5G": "9.5", "OnePlus 8 Pro": "9.8", "Asus ROG Phone II": "6.2", "vivo iQOO": "11", "Sony Xperia 1 II": "10", "OnePlus 7T Pro": "9.6", "Samsung Galaxy Note10+ 5G": "11", "OnePlus 7T": "11", "Lenovo Z6 Pro": "9.8", "Samsung Tab S6 WiFi": "10", "Samsung Galaxy S10": "11", "Samsung Galaxy Note10": "13", "Samsung Galaxy S10+": "12", "OnePlus 7": "11", "Samsung Galaxy Note10+": "12", "Xiaomi Mi 9": "11", "Samsung Galaxy S10e": "12", "Xiaomi Mi 9T Pro": "11", "OnePlus 7 Pro": "10", "Asus Zenfone 6": "11", "LG G8 ThinQ": "11", "Samsung Galaxy S10 Lite": "11", "ZTE Axon 10 Pro 5G": "11", "Oppo Reno 5G": "11", "LG V50 ThinQ 5G": "9.8", "Xiaomi Redmi K20 Pro": "12", "Samsung Galaxy A90 5G": "10", "Lenovo Z5 Pro GT": "10", "Sony Xperia 1": "8.5", "Oppo Reno 10x zoom": "9.8", "Sony Xperia 5": "11", "Xiaomi Mi Mix 3 5G": "13", "Meizu 16s": "15", "Samsung Galaxy Z Flip": "9.9", "LG G8S ThinQ": "13", "Huawei Mate 30 Pro": "4.8", "Huawei MatePad Pro": "5", "Honor 30": "5.5", "Honor X10 5G": "5.7", "Huawei nova 7 SE": "5.8", "Honor 30s": "6.1", "Xiaomi Redmi K30 5G Racing": "14", "LG V60 ThinQ (V600N)": "27", "Oppo Find X2 Lite": "12", "Oppo Reno3 Pro 5G": "13", "Asus Zenfone 5z": "7.5", "Google Pixel 4": "19", "Google Pixel 4 XL": "19", "Razer Phone 2": "9.7", "Oppo Find X2 Neo": "14", "Xiaomi Redmi K30 5G": "14", "vivo X50 Pro": "14", "Huawei P30 Pro": "18", "vivo S6 5G": "17", "Honor 20": "17", "Honor 20 Pro": "17", "Huawei Mate 20": "19", "OnePlus 6": "11", "OnePlus 6T": "11", "LG Velvet": "14", "Samsung Galaxy S9+": "59", "Huawei P30": "18", "Xiaomi Pocophone F1": "10", "Honor Magic 2": "19", "Huawei Mate 20 Pro": "19", "Sony Xperia XZ2": "9.8", "Huawei nova 5T": "17", "Sony Xperia XZ3": "11", "Honor View 20": "23", "Samsung Galaxy S9": "11", "Sony Xperia XZ2 Compact": "11", "Xiaomi Mi 10 Youth 5G": "15", "Xiaomi Mi Mix 3": "9.3", "Huawei Mate 20 X": "15", "Xiaomi Mi Mix 2S": "9.2", "Sony Xperia XZ2 Premium": "11", "Xiaomi Mi 8": "11", "Sharp Aquos R2": "12", "Honor 9X Pro": "9", "Huawei P40 lite": "9.2", "Honor 20S": "9.5", "Realme X2": "13", "Samsung Galaxy Note9": "62", "LG G7 ThinQ": "11", "Realme 6 Pro": "13", "Samsung Galaxy A71 5G": "22", "Meizu 16": "16", "LG V40 ThinQ": "13", "Xiaomi Mi Note 10 Pro": "14", "Xiaomi Redmi Note 9 Pro": "13", "Xiaomi Redmi Note 9S": "13", "Oppo Reno2": "14", "Samsung Galaxy A71": "14", "Samsung Galaxy A80": "14", "Xiaomi Mi Note 10": "15", "Oppo Reno2 Z": "28", "Xiaomi Mi Note 10 Lite": "14", "Xiaomi Redmi K30": "14", "Xiaomi Poco X2": "14", "Xiaomi Mi 9T": "15", "Oppo Reno Z": "23", "Motorola Z2 Force": "13", "Realme XT": "14", "Nokia 8": "14", "LG V30": "13", "Xiaomi Mi Mix 2": "15", "Realme X": "17", "Xiaomi Mi 6": "15", "Samsung Galaxy Note8": "170", "vivo V17": "21", "HTC U11": "18", "HTC U11 Plus": "18", "Samsung Galaxy S8": "172", "Motorola One Hyper": "20", "Huawei nova 4": "14", "Honor View 10": "14", "Samsung Galaxy S8+": "205", "Honor 10": "14", "Huawei P20 Pro": "14", "Huawei Mate 10 Pro": "14", "Xiaomi Redmi Note 7 Pro": "22", "vivo Z1 Pro": "20", "vivo U20": "22", "vivo V19": "18", "Meizu 16Xs": "23", "Xiaomi Mi 9 SE": "17", "Meizu Note 9": "22", "OnePlus 3T": "20", "HTC U12 Plus": "17", "Lenovo ZUK Z2": "21", "LG G6": "25", "Samsung Galaxy A70": "23", "Oppo RX17 Pro": "20", "vivo Z5x": "18", "Xiaomi Mi 9 Lite": "19", "Samsung Galaxy A60": "21", "Sony Xperia XZ": "23", "Blackview BV9900": "39", "Ulefone Armor 7": "42", "Xiaomi Mi CC9": "19", "Realme 3 Pro": "23", "vivo Z1x": "18", "Doogee S95 Pro": "44", "Motorola Z4": "24", "Oppo Reno A": "20", "Ulefone Armor 7E": "47", "Lenovo Z6 Youth": "19", "Samsung Galaxy S7": "199", "Lenovo Z5s": "19", "Xiaomi Mi 8 SE": "19", "Blackview BV9900 Pro": "48", "Motorola One Zoom": "24", "HTC 10": "19", "Samsung Galaxy S7 edge": "200", "OnePlus 5T": "18", "OnePlus 5": "20", "Google Pixel 3": "24", "Sony Xperia XZ1": "17", "Sony Xperia XZ1 Compact": "17", "Google Pixel 3 XL": "32", "Xiaomi Redmi Note 8 Pro": "25", "Oppo Reno3": "56", "Realme 6": "21", "Google Pixel 3a": "33", "Google Pixel 3a XL": "35", "Realme 5i": "26", "UMIDIGI S5 Pro": "38", "Oppo Reno": "24", "Realme 5": "27", "Xiaomi Mi Pad 4 Plus": "22", "TCL 10L": "28", "Xiaomi Mi Note 3": "22", "Sharp Aquos S2": "189", "Motorola G Pro": "29", "Motorola G8 Power": "29", "Motorola G Power": "29", "Oppo A5 (2020)": "28", "Xiaomi Mi A3": "29", "Sony Xperia 10 II": "32", "Oppo A92": "28", "Zebra TC57": "24", "Oppo A9 (2020)": "30", "vivo S1 Pro": "32", "Xiaomi Redmi Note 8": "29", "Xiaomi Redmi Note 8T": "29", "Motorola G8": "29", "vivo Y50": "28", "Motorola G8 Plus": "30", "Huawei P40 lite E": "37", "Huawei P Smart Z": "39", "Meizu X8": "22", "Meizu 16X": "23", "Honor Play 4T": "38", "Huawei P30 lite": "38", "Huawei P smart": "38", "Xiaomi Mi 8 Lite": "24", "Motorola Moto Z": "60", "Sony Xperia Z5 Compact": "27", "Realme 2 Pro": "21", "Samsung Galaxy A9": "26", "Xiaomi Mi A2": "26", "vivo V15": "195", "Xiaomi Redmi Note 7": "26", "LG G5": "62", "Ulefone Armor 6E": "81", "Xiaomi Redmi Note 7S": "25", "Essential Phone": "50", "Samsung Galaxy Note10 Lite": "63", "Asus Zenfone 5": "27", "Motorola G7 Plus": "30", "vivo S1": "50", "Xiaomi Mi Max 3": "31", "Sony Xperia 10 Plus": "32", "vivo V11i": "209", "vivo Y19": "60", "Oppo F11": "145", "Lenovo S5 Pro": "31", "OPPO F9 Pro": "137", "Motorola Z3 Play": "32", "T-Mobile Revvlry+": "33", "Umidigi Power 3": "49", "Samsung Galaxy A51": "101", "Xiaomi Redmi Note 5 Pro": "32", "Xiaomi Redmi Note 9": "59", "Google Pixel XL": "96", "Asus Zenfone Max Pro (M1)": "32", "Realme 3": "35", "Google Pixel": "100", "Google Pixel 2 XL": "125", "Google Pixel 2": "119", "Oppo F11 Pro": "60", "Google Pixel C": "101", "Honor 8": "172", "Motorola Moto G6 Plus": "31", "Motorola Moto X4": "31", "Realme 6i": "94", "Sony Xperia 10": "28", "Realme C3": "94", "Huawei P9": "168", "Motorola G7 Power": "122", "Huawei P10": "172", "Samsung Galaxy C9 Pro": "125", "Samsung Galaxy Note5": "146", "Sony Xperia X Compact": "121", "Huawei Mate 9": "227", "Fairphone 3": "143", "Huawei P10 Plus": "178", "Samsung Galaxy S6": "151", "Samsung Galaxy M30": "129", "Motorola One Action": "124", "Motorola One Vision": "124", "Samsung Galaxy A40": "127", "Samsung Galaxy A30s": "128", "Motorola One Macro": "172", "Samsung Galaxy M20": "130", "Samsung Galaxy A30": "129", "Xiaomi Redmi 7": "149", "Samsung Galaxy S6 edge": "153", "Samsung Galaxy A20": "134", "Samsung Galaxy S5": "216", "Samsung Galaxy Note FE": "87", "Sony Xperia Z3": "124", "Sony Xperia Z3 Compact": "132", "BlackBerry Keyone": "199", "Meizu Pro 7 Plus": "347", "Wiko WIM": "189", "Motorola G8 Play": "173", "Lenovo P2": "190", "Samsung Galaxy A21s": "132", "HTC One (M8)": "181", "LG Nexus 5": "111", "Xiaomi Redmi Note 4": "194", "Xiaomi Mi A1": "153", "Xiaomi Mi Max 2": "195", "Asus Zenfone 3": "202", "vivo V5 Plus": "198", "Huawei nova": "194", "Xiaomi Redmi 5 Plus": "195", "Motorola G7 Play": "172", "Sharp Aquos C10": "204", "Alcatel 1S": "172", "Motorola P30 Play": "199", "Honor 6X": "209", "Meizu M6 Note": "192", "Lenovo S5": "207", "Huawei P20 lite": "160", "Samsung Galaxy A8": "247", "Huawei P10 Lite": "202", "Huawei P8 Lite": "205", "Samsung Galaxy A10": "151", "Huawei Y7 Pro": "212", "Xiaomi Mi Play": "325", "ZTE Blade V10 Vita": "182", "Wiko Y80": "176", "Huawei Y7": "216", "LG G4": "258", "Huawei Y7 Prime": "218", "Xiaomi Mi A2 Lite": "203", "ZTE Blade V9": "222", "Huawei P9 lite": "205", "Samsung Galaxy A5": "243", "LG Stylo 5": "146", "Xiaomi Redmi 5": "216", "LG V10": "207", "Xiaomi Mi Pad": "134", "Lenovo K3 Note": "199", "Samsung Galaxy A20s": "217", "YU Yutopia": "164", "Samsung Galaxy A10e": "335", "Samsung Galaxy Tab A 8.0": "160", "Nokia 3 V": "212", "Motorola G8 Power Lite": "267", "Sony Xperia XA1": "259", "LG Stylo 6": "247", "Xiaomi Redmi 8": "262", "Xiaomi Mi Pad 2": "199", "ZTE Blade V9 Vita": "283", "UMIDIGI A3X": "234", "Samsung Galaxy A01": "244", "vivo Y15": "260", "Motorola E6 Plus": "265", "Xiaomi Redmi Y1": "286", "Lenovo K6 Note": "283", "Sony Xperia L4": "279", "Asus Zenfone 3 Max": "251", "HTC One": "194", "Wiko View2": "287", "Motorola G6": "180", "Xiaomi Redmi 4X": "282", "Asus Zenfone Max Plus": "330", "Sony Xperia Z": "215", "Samsung Galaxy A6+": "278", "Raspberry Pi 4": "173", "Xiaomi Redmi 6": "253", "Samsung Galaxy A10s": "280", "Samsung Galaxy A11": "280", "Samsung Galaxy M11": "280", "Samsung Galaxy J7 Prime": "317", "Samsung Galaxy J7": "318", "Xiaomi Redmi 5A": "242", "Xiaomi Mi 5c": "233", "Honor 8S": "230", "Samsung Galaxy A6": "286", "Samsung Galaxy J5": "376", "Xiaomi Redmi 6A": "153", "Huawei Y5": "236", "Samsung Galaxy J7 Pro": "733", "Xiaomi Redmi 3": "269", "Blackview A80 Pro": "300", "Alcatel 3x": "343", "Samsung Galaxy J6": "307", "Samsung Galaxy S5 Neo": "303", "Umidigi A5 Pro": "370", "Ulefone Armor X5": "356", "Sony Xperia L1": "237", "Samsung Galaxy Note 3": "202", "Meizu M2": "281", "Huawei Y5 Prime": "271", "Sony Xperia M4 Aqua": "334", "Xiaomi Redmi 7A": "485", "Xiaomi Redmi 8A": "516", "Motorola Moto X Play": "312", "Samsung Galaxy J3": "643", "Samsung Galaxy J5 Prime": "336", "Motorola G6 Play": "263", "Lenovo Vibe P1m": "328", "Motorola E4 Plus": "386", "ZTE Blade X3": "319", "ZTE Blade A452": "322", "Asus Zenfone 2": "548", "Asus Zenpad 10": "664", "Nokia 1": "331", "Samsung Galaxy Xcover 3": "669", "Asus Live G500TG": "668", "Asus Google Nexus 7": "622", "Samsung Galaxy S5 mini": "745", "Motorola Moto G2": "695", "Huawei Y560": "797", "Sony Xperia M2 Aqua": "807"}